--
-- A level for Enigma: Laser Arena
--
-- Copyright (c) 2005 Andreas Lochmann
-- License: GPL v.2
-- Created with the help of BBE 1.05

Require("levels/ant.lua")
function file_oxyd(x,y,f)
    oxyd_default_flavor=f
    oxyd(x,y)
end
levelh=13
levelw=20
enigma.FlatForce=30
enigma.SlopeForce=30
enigma.ElectricForce=30
cells={}
items={}
actors={}
stones={}
actors[" "]=cell{}
stones[" "]=cell{}
cells[" "]=cell{}
items[" "]=cell{}
cells["!"]=cell{floor="fl-sand"}
stones["!"]=cell{stone="st-likeoxyda"}
stones["#"]=cell{parent={{file_oxyd,"a"}}}
function ac_blackball(x,y)
n=""
p=0
f=0
 if (x==9) and (y==6) then
  n="ac9x6"
  p=0
  mf=1,66666666666667
 end
set_actor("ac-blackball",x+0.5,y+0.5,{player=p,name=n,mouseforce=mf})
end
actors["!"]=cell{parent={{ac_blackball}}}
level={"!!!!!!!!!!!!!!!!!!!!",
       "!!!!!!!!!!!!!!!!!!!!",
       "!!!!!!!!!!!!!!!!!!!!",
       "!!!!!!!!!!!!!!!!!!!!",
       "!!!!!!!!!!!!!!!!!!!!",
       "!!!!!!!!!!!!!!!!!!!!",
       "!!!!!!!!!!!!!!!!!!!!",
       "!!!!!!!!!!!!!!!!!!!!",
       "!!!!!!!!!!!!!!!!!!!!",
       "!!!!!!!!!!!!!!!!!!!!",
       "!!!!!!!!!!!!!!!!!!!!",
       "!!!!!!!!!!!!!!!!!!!!",
       "!!!!!!!!!!!!!!!!!!!!"}
   acmap={"                    ",
          "                    ",
          "                    ",
          "                    ",
          "                    ",
          "                    ",
          "         !          ",
          "                    ",
          "                    ",
          "                    ",
          "                    ",
          "                    ",
          "                    "}
  itmap={"                    ",
         "                    ",
         "                    ",
         "                    ",
         "                    ",
         "                    ",
         "                    ",
         "                    ",
         "                    ",
         "                    ",
         "                    ",
         "                    ",
         "                    "}
 stmap={"!!!!!!!!!!!!!!!!!!!!",
        "!                  !",
        "!                  !",
        "!                  !",
        "!                  !",
        "!                  !",
        "!                  !",
        "!                  !",
        "!                  !",
        "!                  !",
        "!                  !",
        "!                  !",
        "!!!!!!!!!!!!!!!!!!!!"}
create_world_by_map(level)
draw_map(0,0,stmap,stones)
draw_map(0,0,itmap,items)
draw_map(0,0,acmap,actors)

oxydx = {}
oxydy = {}
laserx = {}
lasery = {}
TIMERINT = 1.0
ANZLASER = 3
if difficult then ANZLASER = 5 end

--stones["$"]=cell{stone="st-laser-e"}
--stones["%"]=cell{stone="st-laser-s"}
--stones["&"]=cell{stone="st-laser-n"}
--stones["'"]=cell{stone="st-laser-w"}

function makelaser(x,y)
  if x == 0 then
    set_stone("st-laser-e", x, y, {on = 1})
  end
  if x == 19 then
    set_stone("st-laser-w", x, y, {on = 1})
  end
  if y == 0 then
    set_stone("st-laser-s", x, y, {on = 1})
  end
  if y == 12 then
    set_stone("st-laser-n", x, y, {on = 1})
  end
end

function timercallback()
  for i = 1,ANZLASER do
    x = laserx[i]
    y = lasery[i]
    if x == 0 then
      lasery[i] = lasery[i] + 1
      if lasery[i] == 12 then laserx[i] = laserx[i] + 1 end
    end
    if x == 19 then
      lasery[i] = lasery[i] - 1
      if lasery[i] == 0 then laserx[i] = laserx[i] - 1 end
    end
    if y == 0 then
      laserx[i] = laserx[i] - 1
      if laserx[i] == 0 then lasery[i] = lasery[i] + 1 end
    end
    if y == 12 then
      laserx[i] = laserx[i] + 1
      if laserx[i] == 19 then lasery[i] = lasery[i] - 1 end
    end      

    drawit = 1
    for j = 1,8 do
      if(oxydx[j] == x) and (oxydy[j] == y) then  drawit = 0  end
    end
    if drawit == 1 then
      set_stone("st-likeoxyda", x, y)
    end

    drawit = 1
    for j = 1,8 do
      if(oxydx[j] == laserx[i]) and (oxydy[j] == lasery[i]) then  drawit = 0  end
    end
    if drawit == 1 then
      makelaser(laserx[i], lasery[i])
    end
  end
end

set_stone("st-timer", 10, 6, {action="callback", target="timercallback", interval=TIMERINT} )
for i = 1,8 do
  oxydx[i] = 0
  oxydy[i] = 0
end
for c = 1,100 do
  if oxydx[1] == oxydx[2] then
    oxydx[1] = random(2,17)
    oxydx[2] = random(2,17)
    oxydy[1] = 0
    oxydy[2] = 0
  end
end
for c = 1,100 do
  if oxydx[3] == oxydx[4] then
    --oxydx[3] = random(2,17)
    oxydx[3] = oxydx[1]
    oxydx[4] = random(2,17)
    oxydy[3] = 12
    oxydy[4] = 12
  end
end
for c = 1,100 do
  if oxydy[5] == oxydy[6] then
    oxydy[5] = random(2,10)
    oxydy[6] = random(2,10)
    oxydx[5] = 0
    oxydx[6] = 0
  end
end
for c = 1,100 do
  if oxydy[7] == oxydy[8] then
    --oxydy[7] = random(2,10)
    oxydy[7] = oxydy[5]
    oxydy[8] = random(2,10)
    oxydx[7] = 19
    oxydx[8] = 19
  end
end

for i = 1,ANZLASER do
  laserx[i] = 0
  lasery[i] = 0
  for c = 1,100 do 
    if laserx[i] == lasery[i] then
      laserx[i] = random(1,18)
      lasery[i] = random(1,11)
      r = random(1,6)
      if r <  3  then  lasery[i] = 0   end
      if r == 3  then  laserx[i] = 0   end
      if r == 4  then  laserx[i] = 19  end
      if r  > 4  then  lasery[i] = 12  end
      for j = 1, 8 do
        if(laserx[i] == oxydx[j]) and (lasery[i] == oxydy[j]) then
          laserx[i] = 0
          lasery[i] = 0
        end
      end
      for j = 1, i-1 do
        if(laserx[i] == laserx[j]) and (lasery[i] == lasery[j]) then
          laserx[i] = 0
          lasery[i] = 0
        end
      end      
    end
  end  
end

oxyd_default_flavor = "a"
for i = 1,8 do
  oxyd(oxydx[i], oxydy[i])
end
for i = 1,ANZLASER do
  makelaser(laserx[i], lasery[i])
end


oxyd_shuffle()
enigma.ConserveLevel = FALSE
